/*
   Simple integer arithmetic Calculator
   according to the EBNF:

   <e> -> <t> {<add> <t>}
   <add> -> + | -
   <t> -> <f> {<mul> <f>}
   <mul> -> *
   <f> -> ( <e> ) | Number

   Inputs a line of text from stdin
   Outputs "Error" or the result.
*/

#include <stdio.h>
#include <stdlib.h>

char token;

int exp(void);
int term(void);
int factor(void);

void error(void)
{ fprintf(stderr,"Error\n");
  exit(1);
}

void match( char expectedToken)
{ if (token==expectedToken) token = getchar();
  else error();
}

main()
{ int result;
  token = getchar();
  result = exp();
  if (token=='\n') printf("Result = %d\n",result);
  else error();
  return 0;
}

int exp(void)
{ int temp = term();
  while ((token=='+')||(token=='-'))
    switch (token) 
    { case '+': match('+'); temp += term(); break;
      case '-': match('-'); temp -= term(); break;
    }
  return temp;
}

int term(void)
{ int temp = factor();
  while (token=='*')
  { match('*'); temp *= factor(); }
  return temp;
}

int factor(void)
{ int temp;
  if (token=='(')
  { match('('); temp = exp(); match(')'); }
  else if (isdigit(token))
  { ungetc(token,stdin);
    scanf("%d",&temp);
    token = getchar();
  }
  else error();
  return temp;
}
